---
- name: check if the is a certificates already
  shell: "oc --config={{ dest_kubeconfig }} get secret -n openshift-ingress | grep 'custom-certs-default'"
  ignore_errors: yes
  register: certs_true

- block:
    - name: create temp directory
      tempfile:
        suffix: build
        state: directory
      register: tempdir

    - name: fetch certificates files
      get_url:
        url: "http://{{ ocp_web }}/ocp4-certificates/{{ cluster_name }}/{{ item }}"
        dest: "{{ tempdir.path }}/{{ item }}"
        remote_src: yes
      with_items:
        - api.crt
        - api.key
        - apps.crt
        - apps.key
        
    - name: get number og workers
      shell: "oc --config={{ dest_kubeconfig }} get nodes | grep worker | wc -l"
      register: workers
      
    - name: create user-ca-bundle config map in openshift-config project
      k8s:
        kubeconfig: "{{ dest_kubeconfig }}"
        definition: "{{ lookup('template', './user-ca-bundle.yaml') }}"
        state: present
        
    - name: configure proxy/cluster source
      shell: "oc --config={{ dest_kubeconfig }} patch  proxy/cluster --type=merge --patch='{\"spec\":{\"trustedCA\":{\"name\":\"user-ca-bundle\"}}}'"
      
    - name: create secret in openshift-ingress project
      shell: "oc --config={{ dest_kubeconfig }} create secret tls custom-certs-default --cert={{ tempdir.path }}/apps.crt --key={{ tempdir.path }}/apps.key -n openshift-ingress"
      
    - name: patch certificate in openshift-ingress-operator project
      shell: "oc --config={{ dest_kubeconfig }} patch ingresscontroller.operator default --type=merge -p '{\"spec\":{\"defaultCertificate\":{\"name\":\"custom-certs-default\"}}}' -n openshift-ingress-operator"

    - name: check ingresscontroller replicas
      shell: "oc --config={{ dest_kubeconfig }} get -n openshift-ingress-operator ingresscontrollers/default -o jsonpath='{$.status.availableReplicas}'"
      register: available_replicas
      until: available_replicas.stdout is search(workers.stdout)
      retries: 30
      delay: 10

    - name: patch certificate in openshift-config project
      shell: "oc --config={{ dest_kubeconfig }} create secret tls custom-certs-api --cert={{ tempdir.path }}/api.crt --key={{ tempdir.path }}/api.key -n openshift-config"

    - name: patch certificate in apiserver project
      shell: "oc --config={{ dest_kubeconfig }} patch apiserver cluster --type=merge -p '{\"spec\":{\"servingCerts\":{\"namedCertificates\":[{\"names\":[\"api.{{ cluster_name }}.{{ base_domain }}\"],\"servingCertificate\":{\"name\":\"custom-certs-api\"}}]}}}'"

    - name: send a massage to splunk
      uri: 
        url: https://splunk.cloudlet-dev.com:8088/services/collector/event
        method: POST
        body: '{"event": {"event_type": "cluster-certificates", "cluster_name": "{{ cluster_name }}", "cluster_certificates": "TRUE" }}'
        body_format: json
        headers:
          Content-Type: "application/json"
          Authorization: "Splunk 1853ec2e-8243-4e07-869b-ceb548bcbecd"
        validate_certs: no
    
    ######delete certs######
    #- name: delete temp cluster name dir content in web server
    #  file: 
    #    path: "/var/www/html/ocp4-certificates/{{ cluster_name }}"
    #    state: absent
    #  delegate_to: "{{ ocp_web }}"
    ######delete certs######
  when: 'openshift_custom_certificates and certs_true.stdout==""'
  
- name: send a massage to splunk
  uri: 
    url: https://splunk.cloudlet-dev.com:8088/services/collector/event
    method: POST
    body: '{"event": {"event_type": "cluster-certificates", "cluster_name": "{{ cluster_name }}", "cluster_certificates": "FALSE" }}'
    body_format: json
    headers:
      Content-Type: "application/json"
      Authorization: "Splunk 1853ec2e-8243-4e07-869b-ceb548bcbecd"
    validate_certs: no
  when: not openshift_custom_certificates